 % The Ensemble of SF SR EC and SP constraint handling methods
 function results=ECHT_DE(Prob_Set_Par, func_num_Par)
global  nfeval
format long e;

 func_num = func_num_Par;    % Function Number
 NP       = 50;    % Size of Population
 Prob_Set = Prob_Set_Par;     
 %  Max_FES  = [240000,240000,100000,200000,400000,400000,240000,240000];% Maximum number of function evaluations
 Max_FES  = [240000,240000,240000,240000,240000,240000,240000,240000,240000,240000, 240000,240000,240000,240000,480000,480000,240000,240000];
%  Max_FES  = [9*20000,11*20000,9*20000,6*20000,48*20000,38*20000];
 Max_FES  = Max_FES(func_num);
%  Max_FES=240000;%240000
 Max_Gen  = Max_FES/(4*NP); %1200;  % Maximum number of generations
 max_run=25;
 best_known=[-1.0005001000  5126.4967140071   0.7499000000   0.0539415140  -47.7648884595 961.7150222899 8853.5396748064 193.7245100700 236.4309755040 -400.0551000000 ...
     189.311629686621  7.049036954314099e+03   -3.882595200000000e-01    -4.000055999999998e+02  1.863830408000000e+00 2.115862756945173e+00  2.5576545740E+00 9.9238463653e+01];
 best_known=best_known(func_num);
Par     = Cal_par(Prob_Set ,func_num);
D       = Par.n;
g       = Par.g;
h       = Par.h;
Xmin    = Par.xmin;
Xmax    = Par.xmax;

  tic   
 for runs=1:max_run % Number of runs
     aa=0;
     fprintf('Run %d',runs);
     nfeval=0;    
     for k=1:4  
         pop=repmat(Xmin,NP,1)+repmat((Xmax-Xmin),NP,1).*rand(NP,D);


         if (Prob_Set == 1)
             [val(:,1), g, h] = RWCOP(pop,func_num);
         else
             [val(:,1), g, h] = AVR_RWCOP(pop,func_num);
         end
         nfeval=nfeval+NP;
         eval(['pop' num2str(k) '=pop;']);
         eval(['val' num2str(k) '=val;']);
         eval(['g' num2str(k) '=g;']);
         eval(['h' num2str(k) '=h;']);
     end
     ub=repmat(Xmax,NP,1);%
     lb=repmat(Xmin,NP,1);%
     
     Tc=0.2*Max_Gen;
     cp=5;
     CONV=abs([h1,h2,h3,h4]);
     if(~isempty(CONV) & ~isempty(find(CONV>0)))
         DELTA=median(median(CONV,2));
         numD=10^(log10(DELTA/10^(-4))/600);
     else
         DELTA=10^(-4);
         numD=1;
     end
     Sr(1)=0.475;    % Parameters of Stochastic Ranking
     dSr=(Sr(1)-0.025)/Max_Gen;
     rot=(0:1:NP-1);
     gen1=1;gen2=[];
     for gen=1:Max_Gen
         %Adaptation of delta for equality constraint
         if(gen==1)
             delta=DELTA;
         else
             delta=max(10^(-4),DELTA/(numD^gen));
         end
         
         for k=1:4
             pop=eval(['pop' num2str(k)]);
             val=eval(['val' num2str(k)]);
             g=eval(['g' num2str(k)]);
             h=eval(['h' num2str(k)]);
             FM_mui = rand(NP,D) < 0.9;
             FM_mpo = FM_mui < 0.5;
             ind=randperm(2);
             FVr_a1 = randperm(NP);
             rt=rem(rot+ind(1),NP);
             FVr_a2 = FVr_a1(rt+1);
             rt=rem(rot+ind(2),NP);
             FVr_a3 = FVr_a2(rt+1);
             
             newpop(1:NP,:)=pop(FVr_a1,:)+ 0.7*(pop(FVr_a2,:)-pop(FVr_a3,:));
             for i=1:NP  
                 
                 for kk=1:D
                     if(newpop(i,kk) < Xmin(kk))
                         newpop(i,kk)= Xmin(kk)+( Xmax(kk)- Xmin(kk)).*rand;
                     end
                     if(newpop(i,kk) > Xmax(kk))
                         newpop(i,kk)= Xmin(kk)+( Xmax(kk)- Xmin(kk)).*rand;
                     end
                 end
             end
             newpop = pop.*FM_mpo + newpop.*FM_mui;
             
             if(Prob_Set == 1)
                 [newval(:,1),newg,newh]=RWCOP(newpop,func_num);
             else
                 [newval(:,1),newg,newh]=AVR_RWCOP(newpop,func_num);
             end
             nfeval=nfeval+NP;
             
             eval(['newpop' num2str(k) '=newpop;']);
             eval(['newval' num2str(k) '=newval;']);
             eval(['newg' num2str(k) '=newg;']);
             eval(['newh' num2str(k) '=newh;']);

         end
         
         for ii=1:4
             A=[];
             B=[];
             G=[];
             H=[];
             
             A=eval(['pop' num2str(ii)]);
             B=eval(['val' num2str(ii)]);
             G=eval(['g' num2str(ii)]);
             H=eval(['h' num2str(ii)]);
             
             A=[A;eval(['newpop' num2str(ii)])];%
             B=[B;eval(['newval' num2str(ii)])];
             G=[G,eval(['newg' num2str(ii)])];%
             H=[H,eval(['newh' num2str(ii)])];
             
             for jj=1:4
                 if(jj~=ii)
                     A=[A;eval(['newpop' num2str(jj)])];
                     B=[B;eval(['newval' num2str(jj)])];
                     G=[G,eval(['newg' num2str(jj)])];
                     H=[H,eval(['newh' num2str(jj)])];
                 end
             end
             
             eval(['A' num2str(ii) '=A;']);
             eval(['B' num2str(ii) '=B;']);
             eval(['G' num2str(ii) '=G;']);
             eval(['H' num2str(ii) '=H;']);
         end
         
         % Superiority of Feasible Solutions
         cons1=[(G1>0).*G1;((abs(H1)-delta)>0).*(abs(H1)-delta)]';
         cons_max1=max(cons1,[],1);
         nzindex1=find(cons_max1~=0);
         
         if isempty(nzindex1)
             tcons1=zeros(size(A1,1),1);
         else
             tcons1=sum(cons1(:,nzindex1)./repmat(cons_max1(:,nzindex1),size(A1,1),1),2)./sum(1./cons_max1(:,nzindex1));
         end
         
         for i=2*NP+1:5*NP
             for kk=NP+1:2*NP
                 DIST(kk-NP,1)=sum((A1(i,:)-A1(kk,:)).^2,2);
             end
             [vinde,inde]=min(DIST,[],1);
             if(((tcons1(i)<tcons1(NP+inde)) | ((tcons1(i)==0) & (tcons1(NP+inde)==0) & (B1(i)<=B1(NP+inde)))))
                 A1(NP+inde,:)= A1(i,:);
                 B1(NP+inde,:)= B1(i,:);
                 G1(:,NP+inde)  = G1(:,i);
                 H1(:,NP+inde)  = H1(:,i);
                 tcons1(NP+inde)=tcons1(i,:);
             end
         end
         
         for kk=1:NP
             if(((tcons1(NP+kk)<tcons1(kk)) | ((tcons1(NP+kk)==0) & (tcons1(kk)==0) & (B1(NP+kk)<=B1(kk)))))
                 pop1(kk,:)= A1(NP+kk,:);
                 val1(kk,:)= B1(NP+kk,:);
                 g1(:,kk)  = G1(:,NP+kk);
                 h1(:,kk)  = H1(:,NP+kk);
             end
         end
         
         %Self-Adaptive Penalty
         cons2=[(G2>0).*G2;((abs(H2)-delta)>0).*(abs(H2)-delta)]';
         cons_max2=max(cons2,[],1);
         nzindex2=find(cons_max2~=0);
         
         if isempty(nzindex2)
             tcons2=zeros(size(A2,1),1);
         else
             
             tcons2=sum(cons2(:,nzindex2)./repmat(cons_max2(:,nzindex2),size(A2,1),1),2)./sum(1./cons_max2(:,nzindex2));
         end
         
         f2=SaPenalty(B2,tcons2,A2);
         for i=2*NP+1:5*NP
             for kk=NP+1:2*NP
                 DIST(kk-NP,1)=sum((A2(i,:)-A2(kk,:)).^2,2);
             end
             [vinde,inde]=min(DIST,[],1);
             if((f2(i)<=f2(NP+inde)))
                 A2(NP+inde,:)= A2(i,:);
                 B2(NP+inde,:)= B2(i,:);
                 G2(:,NP+inde)  = G2(:,i);
                 H2(:,NP+inde)  = H2(:,i);
                 f2(NP+inde,:) = f2(i,:);
             end
         end
         
         for kk=1:NP
             if((f2(NP+kk)<=f2(kk)))
                 pop2(kk,:)= A2(NP+kk,:);
                 val2(kk,:)= B2(NP+kk,:);
                 g2(:,kk)  = G2(:,NP+kk);
                 h2(:,kk)  = H2(:,NP+kk);
             end
         end
         
         %Epsilon Constraint
         cons3=[(G3>0).*G3;((abs(H3)-delta)>0).*(abs(H3)-delta)]';
         cons_max3=max(cons3,[],1);
         nzindex3=find(cons_max3~=0);
         
         if isempty(nzindex3)
             tcons3=zeros(size(A3,1),1);
         else
             tcons3=sum(cons3(:,nzindex3)./repmat(cons_max3(:,nzindex3),size(A3,1),1),2)./sum(1./cons_max3(:,nzindex3));
         end
         
         if(gen==1)
             n=ceil(0.05*size(A3,1));
             [temp,index]=sort(tcons3);
             EPSILON=tcons3(index(n),:);
             epsilon(gen)=EPSILON;
         elseif(gen>1 && gen<=Tc)
             epsilon(gen)=EPSILON*((1-gen/Tc)^cp);
         elseif(gen>Tc)
             epsilon(gen)=0;
         end
         for i=2*NP+1:5*NP
             
             for kk=NP+1:2*NP
                 DIST(kk-NP,1)=sum((A3(i,:)-A3(kk,:)).^2,2); 
             end
             [vinde,inde]=min(DIST,[],1);
             if(((tcons3(NP+inde)<=epsilon(gen) & tcons3(i)<=epsilon(gen) & B3(i) <= B3(inde))|(tcons3(i)<tcons3(NP+inde))))
                 A3(NP+inde,:)= A3(i,:);
                 B3(NP+inde,:)= B3(i,:);
                 G3(:,NP+inde)  = G3(:,i);
                 H3(:,NP+inde)  = H3(:,i);
                 tcons3(NP+inde,:)=tcons3(i,:);
             end
         end
         for kk=1:NP
             if(((tcons3(kk)<=epsilon(gen) & tcons3(NP+kk)<=epsilon(gen) & B3(NP+kk) <= B3(kk))|(tcons3(NP+kk)<tcons3(kk))))
                 pop3(kk,:)= A3(NP+kk,:);
                 val3(kk,:)= B3(NP+kk,:);
                 g3(:,kk)  = G3(:,NP+kk);
                 h3(:,kk)  = H3(:,NP+kk);
             end
         end
         
         %Stochastic Ranking
         cons4=[(G4>0).*G4;((abs(H4)-delta)>0).*(abs(H4)-delta)]';
         cons_max4=max(cons4,[],1);
         nzindex4=find(cons_max4~=0);
         
         if isempty(nzindex4)
             tcons4=zeros(size(A4,1),1);
         else
             tcons4=sum(cons4(:,nzindex4)./repmat(cons_max4(:,nzindex4),size(A4,1),1),2)./sum(1./cons_max4(:,nzindex4));
         end
         
         if gen>1 & gen< Max_Gen
             Sr(gen)=Sr(gen-1)-dSr;
         elseif(gen>=Max_Gen)
             Sr(gen)=0.025;
         end
         for i=2*NP+1:5*NP
             
             for kk=NP+1:2*NP
                 DIST(kk-NP,1)=sum((A4(i,:)-A4(kk,:)).^2,2);
             end
             [vinde,inde]=min(DIST,[],1);  
             
             if(rand<Sr(gen))
                 if((B4(i) < B4(NP+inde)))
                     A4(NP+inde,:)= A4(i,:);
                     B4(NP+inde,:)= B4(i,:);
                     G4(:,NP+inde)  = G4(:,i);
                     H4(:,NP+inde)  = H4(:,i);
                     tcons4(NP+inde,:)=tcons4(i,:);
                 end
             else
                 if((tcons4(i)<tcons4(NP+inde)) |((tcons4(i)==0 & tcons4(NP+inde)==0) & (B4(i) < B4(NP+inde))))
                     A4(NP+inde,:)= A4(i,:);
                     B4(NP+inde,:)= B4(i,:);
                     G4(:,NP+inde)  = G4(:,i);
                     H4(:,NP+inde)  = H4(:,i);
                     tcons4(NP+inde,:)=tcons4(i,:);
                 end
             end
         end
         
         for kk=1:NP
             if(rand<Sr(gen))
                 if((B4(NP+kk) < B4(kk)))
                     pop4(kk,:)= A4(NP+kk,:);
                     val4(kk,:)= B4(NP+kk,:);
                     g4(:,kk)  = G4(:,NP+kk);
                     h4(:,kk)  = H4(:,NP+kk);
                 end
             else
                 if((tcons4(NP+kk) < tcons4(kk)) | ((tcons4(NP+kk)==0 & tcons4(kk)==0) & (B4(NP+kk) < B4(kk))))
                     pop4(kk,:)= A4(NP+kk,:);
                     val4(kk,:)= B4(NP+kk,:);
                     g4(:,kk)  = G4(:,NP+kk);
                     h4(:,kk)  = H4(:,NP+kk);
                 end
             end
         end
         
         totalpop=[pop1;pop2;pop3;pop4];
         totalval=[val1;val2;val3;val4];
         totalg=[g1,g2,g3,g4];
         totalh=[h1,h2,h3,h4];
         cons5=[(totalg>0).*totalg;((abs(totalh)-10^(-4))>0).*(abs(totalh)-10^(-4))]';
         cons_max5=max(cons5,[],1);
         nzindex5=find(cons_max5~=0);
         
         if isempty(nzindex5)
             tcons5=zeros(4*NP,1);
         else
             tcons5=sum(cons5(:,nzindex5)./repmat(cons_max5(:,nzindex5),4*NP,1),2)./sum(1./cons_max5(:,nzindex5));
         end
         
         feasindex=find(tcons5==0);
         if isempty(feasindex)
             [gbesttcons,ibest]=min(tcons5);
             gbestval=totalval(ibest);
             gbest = totalpop(ibest,:);
         else
             [gbestval,ibest]=min(totalval(feasindex));
             gbesttcons=tcons5(feasindex(ibest));
             gbest = totalpop(feasindex(ibest),:);
         end
         
         if(gen ==1)
             thegbestval = gbestval;
             thegbesttcons = gbesttcons;
             thegbest(runs,:) = gbest;
         elseif((gbesttcons < thegbesttcons) || (gbesttcons==0 && thegbesttcons ==0 && gbestval < thegbestval))
             thegbestval = gbestval;
             thegbesttcons = gbesttcons;
             thegbest(runs,:) = gbest;
         end
         
         W(gen,1)=thegbestval;
         W(gen,2)=thegbesttcons;
         W(gen,3)=nfeval;
         if gen==1||mod(W(gen,3),Max_FES/20)==0
        aa=aa+1;
        W1(aa,1)=W(gen,1);
        W1(aa,2)=W(gen,3);
        end
     end
     plot(W1(:,2),W1(:,1),'-*')
    fr=find(W(:,2)==0);
    if ~isempty(fr)
        FR(runs,:)=1;
    else
        FR(runs,:)=0;
    end
    [row1,~]=find(W(:,2)==0);
    [sr,~]=find(abs(W(row1,1)-best_known)<abs(0.01*best_known));
    if ~isempty(sr)
        SR(runs,:)=1;
        FES(runs,:)=W(row1(sr(1)),3);
        FES2(runs,:)=length(sr);
        plot(W1(:,2),W1(:,1),'-*')
    else
        SR(runs,:)=0;
        FES(runs,:)=NaN;
        FES2(runs,:)=NaN;
    end
    

     Re(runs,1)=thegbestval;
     Re(runs,2)=thegbesttcons;
     std(Re(:,1))
     toc
 end
FES(isnan(FES))=[];
FES2(isnan(FES2))=[];
FES1=sum(FES,1)/sum(SR,1);%reach
FES3=sum(FES2,1)/sum(SR,1);%mean
FR=100*length(find(FR==1))/max_run;
SR=100*length(find(SR==1))/max_run;
a = find(Re(:,2)==0);
sort_of_solution = [];
if ~isempty(a)
    [~,index11] = sort(abs(Re(a,1)-best_known));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(a(index11(i)), 1), Re(a(index11(i)), 2)];
    end
    Re(a,:) = [];
else
    [~,index11] = sort(Re(:,2));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(index11(i), 1), Re(index11(i), 2)];
    end
    Re = [];
end
if ~isempty(Re)
    [~,index11] = sort(Re(:,2));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(index11(i), 1), Re(index11(i), 2)];
    end
end
Res(1, :) = sort_of_solution(1, 1);
sta_of_vio(1, :) = sort_of_solution(1, 2);
Res(2,:)=median(sort_of_solution(:,1));
sta_of_vio(2, :) = median(sort_of_solution(:,2));
Res(3,:)=mean(sort_of_solution(:,1));
sta_of_vio(3, :) = mean(sort_of_solution(:,2));
Res(4,:)=sort_of_solution(end,1);
sta_of_vio(4, :) = sort_of_solution(end,2);
Res(5,:)=std(sort_of_solution(:,1));
sta_of_vio(5, :) = std(sort_of_solution(:,2));
results=[Res', sta_of_vio', FR, SR];
 
 
