% This Program uses Epsilon Constraint to Solve Constrained Optimization Problems
function EC_EP(Prob_Set_Par, func_num_Par)
global  nfeval
format long e;

func_num = func_num_Par;      % Function Number
NP       = 200;    % Size of Population
Prob_Set = Prob_Set_Par;
Max_FES  = 240000; % Maximum number of function evaluations
Max_Gen  = 4800;

if(Prob_Set == 2)
    Xmin1=[0,0,0,0,1000,0,100,100,100];
    Xmax1=[10,200,100,200,2000000,600,600,600,900];
    Xmin2=[0,0,0,0,1000,0,100,100,100];
    Xmax2=[10,200,100,200,2000000,600,600,600,900];
    Xmin3=zeros(1,9);
    Xmax3=[100,200,100,100,100,100,200,100,200];
    Xmin4=zeros(1,9);
    Xmax4=[100,200,100,100,100,100,200,100,200];
    Xmin5=zeros(1,38);
    Xmax5=[90,150,90,150,90,90,150,90,90,90,150,150,90,90,150,90,150,90,150,90,1,1.2,1,1,1,0.5,1,1,0.5,0.5,0.5,1.2,0.5,1.2,1.2,0.5,1.2,1.2];
    Xmin6=zeros(1,38);
    Xmax6=[90,150,90,150,90,90,150,90,90,90,150,150,90,90,150,90,150,90,150,90,1,1.2,1,1,1,0.5,1,1,0.5,0.5,0.5,1.2,0.5,1.2,1.2,0.5,1.2,1.2];
    Xmin7=[0,0,0,0,0.00001,0.00001];
    Xmax7=[1,1,1,1,16,16];
    Xmin8=[0,0,0,0,0.00001,0.00001];
    Xmax8=[1,1,1,1,16,16];
    Xmin9= [10000,10000,10000,0,0,0,100,100,100,100,100];
    Xmax9=[819000,1131000,2050000,0.05074,0.05074,0.05074,200,300,300,300,400];
    Xmin10=[10000,10000,10000,0,0,0,100,100,100,100,100];
    Xmax10=[819000,1131000,2050000,0.05074,0.05074,0.05074,200,300,300,300,400];
    
    gn=[1  16   2  10   1   38   1   9   1  18];
    hn=[8   1   4   1   32  13   4   1   9   1];
    Dimension=[9,9,9,9,38,38,6,6,11,11];
    D=Dimension(func_num);
    gn=gn(func_num);
    hn=hn(func_num);
    
    eval(['Xmin=Xmin' int2str(func_num) ';']);
    eval(['Xmax=Xmax' int2str(func_num) ';']);
    
end

for runs=1:30  % Specify the number of runs
    
    fprintf('Run %d',runs);
    nfeval=0;
    
    % Initialization and Evaluation  of Population MembersʼȺ壩
    pop=repmat(Xmin,NP,1)+repmat((Xmax-Xmin),NP,1).*rand(NP,D);
    if(Prob_Set == 2)
        [val(:,1), g, h] = RWCOP(pop,func_num);
    end
    nfeval=nfeval+NP;
    
    ub=repmat(Xmax,NP,1);
    lb=repmat(Xmin,NP,1);
    
    TOURNAMENT_SIZE=20; % Tournament size for selection
    CONV=abs(h);
    if(~isempty(CONV) & ~isempty(find(CONV>0)))
        DELTA=max(min(CONV,[],2));
        numD=10^(log10(DELTA/10^(-4))/(Max_Gen/2));
    else
        DELTA=10^(-4);
        numD=1;
    end
    cons=[(g>0).*g;((abs(h)-10^(-4))>0).*(abs(h)-10^(-4))]';
    cons_max=max(cons,[],1);
    nzindex=find(cons_max~=0);
    %Evalauating total constraint violation to evaluate Epsilon Value ԼΥֵ
    if isempty(nzindex)
        tcons=zeros(NP,1);
    else
        tcons=sum(cons(:,nzindex)./repmat(cons_max(nzindex),NP,1),2)./sum(1./cons_max(nzindex));
    end
    
    n=0.05*NP;  % The parameters of the constraint handling method
    Tc=0.5*Max_Gen;
    cp=5;
    [temp,index]=sort(tcons);
    EPSILON=tcons(index(n));
    nretry=10;
    
    for gen=1:Max_Gen
        NN=min(50,ceil((gen/Max_Gen)^5*50));
        %Adaptation of delta for equality constraints
        if(gen==1)
            delta=DELTA;
        else
            delta=max(10^(-4),DELTA/(numD^gen));
        end
        % Initialization and Adaptation of neta values
        if(gen<=10)
            neta=[(0.8/sqrt(D))*rand(NP,D)].*repmat((Xmax-Xmin),NP,1);
        else
            L=[];
            for ind=1:10
                L=[L;eval(['sneta' num2str(ind)])];
            end
            L(~any(L,2),:) = [];
            l=mean(L,1);
            neta=repmat(l,NP,1);
        end
        newneta= neta.*[2*rand(NP,D)-1]+neta;
        index=randi([1,NP],2,1);
        newpop(1,:)=pop(1,:)+0.85*(pop(index(1),:)-pop(index(2),:));
        newpop((2:NP),:)=pop(2:NP,:)+newneta(2:NP,:).*randn((NP-1),D);
        
        I=find((newpop>ub)|(newpop<lb));
        retry=1;
        
        while ~isempty(I)
            newpop(I)=pop(I)+neta(I).*randn(length(I),1);
            I=find((newpop>ub)|(newpop<lb));
            if (retry>nretry)
                break;
            end
            retry=retry+1;
        end
        newpop=(newpop>repmat(Xmin,NP,1)).*newpop+(newpop<repmat(Xmin,NP,1)).*(repmat(Xmin,NP,1));
        newpop=(newpop<repmat(Xmax,NP,1)).*newpop+(newpop>repmat(Xmax,NP,1)).*(repmat(Xmax,NP,1));
        if(Prob_Set == 2)
            [newval(:,1),newg,newh]=RWCOP(newpop,func_num);
        end
        nfeval=nfeval+NP;
        
        A1=[pop;newpop];
        B1=[val;newval];
        F1=[neta;newneta];
        G1=[g,newg];
        H1=[h,newh];
        
        r=rem(gen,10);
        if(r==0)
            r=10;
        end
        if(gen<=60)
            ZZ1=[];
            ZZ2=[];
            ZZ3=[];
            ZZ4=[];
            ZZ5=[];
            zz=[];
            [ZZ1,zz]=unique(A1,'rows');
            ZZ2=B1(zz,:);
            ZZ3=F1(zz,:);
            ZZ4=G1(:,zz);
            ZZ5=H1(:,zz);
            A1=[];
            B1=[];
            F1=[];
            G1=[];
            H1=[];
            A1=ZZ1;
            B1=ZZ2;
            F1=ZZ3;
            G1=ZZ4;
            H1=ZZ5;
        end
        cons1=[(G1>0).*G1;((abs(H1)-delta)>0).*(abs(H1)-delta)]';
        cons_max=max([cons_max;cons1],[],1);
        nzindex=find(cons_max~=0);
        
        if isempty(nzindex)
            tcons1=zeros(size(A1,1),1);
        else
            tcons1=sum(cons1(:,nzindex)./repmat(cons_max(nzindex),size(A1,1),1),2)./sum(1./cons_max(nzindex));
        end
        
        if(gen<=Tc)
            epsilon(gen)=EPSILON*((1-gen/Tc)^cp);
        else
            epsilon(gen)=0;
        end
        for kk=1:size(A1,1)
            win1(kk)=0;
            for i=1:TOURNAMENT_SIZE
                competitor3=ceil(rand(1)*size(A1,1));
                win1(kk)=win1(kk)-(~((tcons1(kk)<=epsilon(gen) & tcons1(competitor3)<=epsilon(gen) & B1(competitor3) <= B1(kk)) |...
                  (tcons1(kk)==tcons1(competitor3) & B1(competitor3) <= B1(kk)) |(tcons1(competitor3)<tcons1(kk))));
            end
        end
        
        [sort_chd1,a] = sortrows([win1',A1,B1,F1,G1',H1',tcons1],1);
        aa=a(1:NP);
        pop=sort_chd1(1:NP,2:(D+1));
        val=sort_chd1(1:NP,(D+2));
        neta=sort_chd1(1:NP,(D+3):(D*2+2));
        win1=sort_chd1(1:NP,1)';
        g=sort_chd1(1:NP,(D*2+3):(D*2+2+gn))';
        h=sort_chd1(1:NP,(D*2+2+gn+1):(D*2+2+gn+hn))';
        tcons1=sort_chd1(1:NP,(D*2+3+gn+hn));
        if(size(find(aa>NP),1)~=0 )
            sneta1=neta(find( aa>NP),:);
        else
            sneta1=[(0.8/sqrt(D))*rand(NP,D)].*repmat((Xmax-Xmin),NP,1);
        end
        eval(['sneta' num2str(r) '=sneta1;']);
        feasindex=find(tcons1==0);
        if isempty(feasindex)
            [gbesttcons,ibest]=min(tcons1);
            gbestval=val(ibest);
            gbest = pop(ibest,:);
        else
            [gbestval,ibest]=min(val(feasindex));
            gbesttcons=tcons1(feasindex(ibest));
            gbest = pop(feasindex(ibest),:);
        end
        
        if(gen ==1)
            thegbestval = gbestval;
            thegbesttcons = gbesttcons;
            thegbest(runs,:) = gbest;
        elseif((gbesttcons < thegbesttcons) | (gbesttcons==0 & thegbesttcons ==0 & gbestval < thegbestval))
            thegbestval = gbestval;
            thegbesttcons = gbesttcons;
            thegbest(runs,:)=gbest;
        end
        
        W(gen,1)=thegbestval;
        W(gen,2)=thegbesttcons;
        W(gen,3)=nfeval;
    end
    
    eval(['save D:\ResultsOfRWCOP\EP-Result\EC-EP-RWCOP/W_' int2str(func_num) ' W;']);
    Re(runs,1)=thegbestval;
    Re(runs,2)=thegbesttcons;
    
end

Res(1)=max(Re(:,1));
Res(2)=min(Re(:,1));
Res(3)=median(Re(:,1));
Res(4)=mean(Re(:,1));
Res(5)=std(Re(:,1));

eval(['save D:\ResultsOfRWCOP\EP-Result\EC-EP-RWCOP/FUN' int2str(func_num)]);


