function [f,g,h] = RWCOP(x,I_fno)
%The original problem
 [ps,D]=size(x);
 
 if (I_fno==11)
    %% Heat Exchanger Network Design (case 1)
    f = 35.*x(:,1).^0.6 + 35.*x(:,2).^0.6;
    g = zeros(ps,1);
    h(:,1) = 200.*x(:,1).*x(:,4)-x(:,3);
    h(:,2) = 200.*x(:,2).*x(:,6)-x(:,5);
    h(:,3) = x(:,3) - 10000.*(x(:,7)-100);
    h(:,4) = x(:,5) - 10000.*(300-x(:,7));
    h(:,5) = x(:,3) - 10000.*(600-x(:,8));
    h(:,6) = x(:,5) - 10000.*(900-x(:,9));
    h(:,7) = x(:,4).*log(abs(x(:,8)-100)+1e-8)-x(:,4).*log((600-x(:,7))+1e-8)-x(:,8)+x(:,7)+500;
    h(:,8) = x(:,6).*log(abs(x(:,9)-x(:,7))+1e-8)-x(:,6).*log(600)-x(:,9)+x(:,7)+600;   
 end

 
 if(I_fno == 12)
    %% Heat Exchanger Network Design (case 2)
    f = (x(:,1)./(120*x(:,4))).^0.6+(x(:,2)./(80*x(:,5))).^0.6+(x(:,3)./(40*x(:,6))).^0.6;
    g = zeros(ps,1);
    h(:,1) = x(:,1)-1e4.*(x(:,7)-100);
    h(:,2) = x(:,2)-1e4.*(x(:,8)-x(:,7));
    h(:,3) = x(:,3)-1e4.*(500-x(:,8));
    h(:,4) = x(:,1)-1e4.*(300-x(:,9));
    h(:,5) = x(:,2)-1e4.*(400-x(:,10));
    h(:,6) = x(:,3)-1e4.*(600-x(:,11));
    h(:,7) = x(:,4).*log(abs(x(:,9)-100)+1e-8)-x(:,4).*log(300-x(:,7)+1e-8)-x(:,9)-x(:,7)+400;
    h(:,8) = x(:,5).*log(abs(x(:,10)-x(:,7))+1e-8)-x(:,5).*log(abs(400-x(:,8))+1e-8)-x(:,10)+x(:,7)-x(:,8)+400;
    h(:,9) = x(:,6).*log(abs(x(:,11)-x(:,8))+1e-8)-x(:,6).*log(100)-x(:,11)+x(:,8)+100;
end

 
 if (I_fno ==14)
    %% Haverly's Pooling Problem
    f = -(9.*x(:,1)+15.*x(:,2)-6.*x(:,3)-16.*x(:,4)-10.*(x(:,5)+x(:,6)));
    g(:,1) = x(:,9).*x(:,7)+2.*x(:,5)-2.5.*x(:,1);
    g(:,2) = x(:,9).*x(:,8)+2.*x(:,6)-1.5.*x(:,2);
    h(:,1) = x(:,7)+x(:,8)-x(:,3)-x(:,4);
    h(:,2) = x(:,1)-x(:,7)-x(:,5);
    h(:,3) = x(:,2)-x(:,8)-x(:,6);
    h(:,4) = x(:,9).*x(:,7)+x(:,9).*x(:,8)-3.*x(:,3)-x(:,4);
 end

 if (I_fno == 13)
    %% Reactor Network Design (RND)
    k1 = 0.09755988;
    k2 = 0.99.*k1;
    k3 = 0.0391908;
    k4 = 0.9.*k3;
    f = -x(:,4);
    h(:,1) = x(:,1)+k1.*x(:,2).*x(:,5)-1;
    h(:,2) = x(:,2)-x(:,1)+k2.*x(:,2).*x(:,6);
    h(:,3) = x(:,3)+x(:,1)+k3.*x(:,3).*x(:,5)-1;
    h(:,4) = x(:,4)-x(:,3)+x(:,2)-x(:,1)+k4.*x(:,4).*x(:,6);
    g(:,1) = x(:,5).^0.5+x(:,6).^0.5-4;
end

 if (I_fno ==16)
 %% Propane, Isobutane, n-Butane Nonsharp Separation
    c = [ 0.23947, 0.75835; -0.0139904, -0.0661588; 0.0093514, 0.0338147;.....
        0.0077308, 0.0373349; -0.0005719, 0.0016371;0.0042656, 0.0288996];
    f = c(1,1)+(c(2,1)+c(3,1).*x(:,24)+c(4,1).*x(:,28)+c(5,1).*x(:,33)+c(6,1).*x(:,34)).*x(:,5)....
        +c(1,2)+(c(2,2)+c(3,2).*x(:,26)+c(4,2).*x(:,31)+c(5,2).*x(:,38)+c(6,2).*x(:,39)).*x(:,13);
    g = zeros(ps,1);
    h(:,1) = x(:,1)+x(:,2)+x(:,3)+x(:,4)-300;
    h(:,2) = x(:,6)-x(:,7)-x(:,8);
    h(:,3) = x(:,9)-x(:,10)-x(:,11)-x(:,12);
    h(:,4) = x(:,14)-x(:,15)-x(:,16)-x(:,17);
    h(:,5) = x(:,18)-x(:,19)-x(:,20);
    h(:,6) = x(:,6).*x(:,21)-x(:,24).*x(:,25);
    h(:,7) = x(:,14).*x(:,22)-x(:,26).*x(:,27);
    h(:,8) = x(:,9).*x(:,23)-x(:,28).*x(:,29);
    h(:,9) = x(:,18).*x(:,30)-x(:,31).*x(:,32);
    h(:,10) = x(:,25)-x(:,5).*x(:,33);
    h(:,11) = x(:,29)-x(:,5).*x(:,34);
    h(:,12) = x(:,35)-x(:,5).*x(:,36);
    h(:,13) = x(:,37)-x(:,13).*x(:,38);
    h(:,14) = x(:,27)-x(:,13).*x(:,39);
    h(:,15) = x(:,32)-x(:,13).*x(:,40);
    h(:,16) = x(:,25)-x(:,6).*x(:,21)-x(:,9).*x(:,41);
    h(:,17) = x(:,29)-x(:,6).*x(:,42)-x(:,9).*x(:,23);
    h(:,18) = x(:,35)-x(:,6).*x(:,43)-x(:,9).*x(:,44);
    h(:,19) = x(:,37)-x(:,14).*x(:,45)-x(:,18).*x(:,46);
    h(:,20) = x(:,27)-x(:,14).*x(:,22)-x(:,18).*x(:,47);
    h(:,21) = x(:,32)-x(:,14).*x(:,48)-x(:,18).*x(:,30);
    h(:,22) = 1/3*x(:,1)+x(:,15).*x(:,45)-x(:,25);
    h(:,23) = 1/3*x(:,1)+x(:,15).*x(:,22)-x(:,29);
    h(:,24) = 1/3*x(:,1)+x(:,15).*x(:,48)-x(:,35);
    h(:,25) = 1/3*x(:,2)+x(:,10).*x(:,41)-x(:,37);
    h(:,26) = 1/3*x(:,2)+x(:,10).*x(:,23)-x(:,27);
    h(:,27) = 1/3*x(:,2)+x(:,10).*x(:,44)-x(:,32);
    h(:,28) = x(:,33)+x(:,34)+x(:,36)-1;
    h(:,29) = x(:,21)+x(:,42)+x(:,43)-1;
    h(:,30) = x(:,41)+x(:,23)+x(:,44)-1;
    h(:,31) = x(:,38)+x(:,39)+x(:,40)-1;
    h(:,32) = x(:,45)+x(:,22)+x(:,48)-1;
    h(:,33) = x(:,46)+x(:,47)+x(:,30)-1;
    h(:,34) = x(:,43);
    h(:,35) = x(:,46);
    h(:,36) = 1/3*x(:,3)+x(:,7).*x(:,21)+x(:,11).*x(:,41)+x(:,16).*x(:,45)+x(:,19).*x(:,46)-30;
    h(:,37) = 1/3*x(:,3)+x(:,7).*x(:,42)+x(:,11).*x(:,23)+x(:,16).*x(:,22)+x(:,19).*x(:,47)-50;
    h(:,38) = 1/3*x(:,3)+x(:,7).*x(:,43)+x(:,11).*x(:,44)+x(:,16).*x(:,48)+x(:,19).*x(:,30)-30;
end
 
 if(I_fno ==15)
%% Blending-Pooling-Separation problem
    f = 0.9979+0.00432.*x(:,5)+0.01517.*x(:,13);
    g = zeros(ps,1);
    h(:,1) = x(:,1)+x(:,2)+x(:,3)+x(:,4)-300;
    h(:,2) = x(:,6)-x(:,7)-x(:,8);
    h(:,3) = x(:,9)-x(:,10)-x(:,11)-x(:,12);
    h(:,4) = x(:,14)-x(:,15)-x(:,16)-x(:,17);
    h(:,5) = x(:,18)-x(:,19)-x(:,20);
    h(:,6) = x(:,5).*x(:,21)-x(:,6).*x(:,22)-x(:,9).*x(:,23);
    h(:,7) = x(:,5).*x(:,24)-x(:,6).*x(:,25)-x(:,9).*x(:,26);
    h(:,8) = x(:,5).*x(:,27)-x(:,6).*x(:,28)-x(:,9).*x(:,29);
    h(:,9) = x(:,13).*x(:,30)-x(:,14).*x(:,31)-x(:,18).*x(:,32);
    h(:,10) = x(:,13).*x(:,33)-x(:,14).*x(:,34)-x(:,18).*x(:,35);
    h(:,11) = x(:,13).*x(:,36)-x(:,14).*x(:,37)-x(:,18).*x(:,38);
    h(:,12) = 1/3.*x(:,1)+x(:,15).*x(:,31)-x(:,5).*x(:,21);
    h(:,13) = 1/3.*x(:,1)+x(:,15).*x(:,34)-x(:,5).*x(:,24);
    h(:,14) = 1/3.*x(:,1)+x(:,15).*x(:,37)-x(:,5).*x(:,27);
    h(:,15) = 1/3.*x(:,2)+x(:,10).*x(:,23)-x(:,13).*x(:,30);
    h(:,16) = 1/3.*x(:,2)+x(:,10).*x(:,26)-x(:,13).*x(:,33);
    h(:,17) = 1/3.*x(:,2)+x(:,10).*x(:,29)-x(:,13).*x(:,36);
    h(:,18) = 1/3.*x(:,3)+x(:,7).*x(:,22)+x(:,11).*x(:,23)+x(:,16).*x(:,31)+x(:,19).*x(:,32)-30;
    h(:,19) = 1/3.*x(:,3)+x(:,7).*x(:,25)+x(:,11).*x(:,26)+x(:,16).*x(:,34)+x(:,19).*x(:,35)-50;
    h(:,20) = 1/3.*x(:,3)+x(:,7).*x(:,28)+x(:,11).*x(:,29)+x(:,16).*x(:,37)+x(:,19).*x(:,38)-30;
    h(:,21) = x(:,21)+x(:,24)+x(:,27)-1;
    h(:,22) = x(:,22)+x(:,25)+x(:,28)-1;
    h(:,23) = x(:,23)+x(:,26)+x(:,29)-1;
    h(:,24) = x(:,30)+x(:,33)+x(:,36)-1;
    h(:,25) = x(:,31)+x(:,34)+x(:,37)-1;
    h(:,26) = x(:,32)+x(:,35)+x(:,38)-1;
    h(:,27) = x(:,25);
    h(:,28) = x(:,28);
    h(:,29) = x(:,23);
    h(:,30) = x(:,37);
    h(:,31) = x(:,32);
    h(:,32) = x(:,35);
 end
 
 if(I_fno ==18)
 %% Two-reactor Problem
        x1 = x(:,1);
        x2 = x(:,2);
        v1 = x(:,3);
        v2 = x(:,4);
        y1 = round(x(:,5));
        y2 = round(x(:,6));
        x_ = x(:,7);
        
        z1 = 0.9*(1-exp(-0.5.*v1)).*x1;
        z2 = 0.8*(1-exp(-0.4*v2)).*x2;
        
        
        f = 7.5.*y1 + 5.5.*y2 + 7.*v1 + 6.*v2 + 5.*x_;
        
        h(:,1) = y1 + y2 - 1;
        h(:,2) = z1 + z2 - 10;
        h(:,3) = x1 + x2 -x_;
        h(:,4) = z1.*y1 + z2.*y2 - 10;
        g(:,1) = v1 - 10*y1;
        g(:,2) = v2 - 10*y2;
        g(:,3) = x1 - 20*y1;
        g(:,4) = x2 - 20*y2;
 end
 
  if(I_fno ==17)
      %% Process synthesis and design problem
    x(:,3) = round(x(:,3));
    f = -x(:,3) + 2*x(:,1) + x(:,2);
    h = x(:,1) - 2*exp(-x(:,2));
    g = -x(:,1)+x(:,2)+x(:,3);
  end
  
   if (I_fno ==1)
%%cec 2006, g03
    f = sqrt(D).^D;
    for i=1:D
        f=f.*x(:,i);
    end
    f=-f;
    g = zeros(ps,1);
    h = sum(x.^2,2)-1;
 
    end
     if (I_fno ==2)
     % g5

          g1 = -x(:,4) + x(:,3) -0.55;
          g2 = -x(:,3) + x (:,4)-0.55;

          f = 3*x(:,1) + 0.000001.*x(:,1).^3 + 2*x(:,2) + (0.000002/3).*x(:,2).^3;
          h(:,1)=1000*sin(-x(:,3)-0.25)+1000*sin(-x(:,4)-0.25)+894.8-x(:,1);
          h(:,2)=1000*sin(x(:,3)-0.25)+1000*sin(x(:,3)-x(:,4)-0.25)+894.8-x(:,2);
          h(:,3)=1000*sin(x(:,4)-0.25)+1000*sin(x(:,4)-x(:,3)-0.25)+1294.8;
          g = [g1,g2];
     end

     if(I_fno ==3) 
    % g11
      f = x(:,1).^2 + (x(:,2)-1).^2;
      g = zeros(ps,1);
      h = x(:,2)-x(:,1).^2;
     end

     if (I_fno ==4)
    % g13
    f=exp(x(:,1).*x(:,2).*x(:,3).*x(:,4).*x(:,5));
    h(:,1)=x(:,1).^2+x(:,2).^2+x(:,3).^2+x(:,4).^2+x(:,5).^2-10;
    h(:,2)=x(:,2).*x(:,3)-5*x(:,4).*x(:,5);
    h(:,3)=x(:,1).^3+x(:,2).^3+1;
    g = zeros(ps,1);

     end
     if(I_fno ==5)
    %  g14
          c = [-6.089,-17.164,-34.054,-5.914,-24.721,-14.986,-24.1,-10.708,-26.662,-22.179];
          RepC = repmat(c,ps,1);
          f = 0;

          h(:,1) = x(:,1)+2*x(:,2)+2*x(:,3)+x(:,6)+x(:,10)-2;
          h(:,2) = x(:,4)+2*x(:,5)+x(:,6)+x(:,7)-1;
          h(:,3) = x(:,3)+x(:,7)+x(:,8)+2*x(:,9)+x(:,10)-1;


          for i=1:10
              temp = x(:,i)./sum(x,2);
              mark = temp<=zeros(ps,1);
              temp = (mark.*100000)+((-mark).*temp + temp);
              f = f+ x(:,i).*(RepC(:,i)+ log(temp));
          end

          g = zeros(ps,1);

     end
     if (I_fno ==6)
    % g15
        f = 1000 - x(:,1).^2 - 2*x(:,2).^2 - x(:,3).^2 - x(:,1).*x(:,2) - x(:,1).*x(:,3);

        h(:,1) = x(:,1).^2+x(:,2).^2+x(:,3).^2 -25 ;
        h(:,2)=8*x(:,1)+14*x(:,2)+7*x(:,3) -56;
        g = zeros(ps,1);

     end
     if(I_fno ==7)
    % g17
      mark1 = (x(:,1)>= 0) & (x(:,1) < 300);
        f1temp1 = 30*(mark1).*x(:,1);
        mark2 = (x(:,1)>= 300) & (x(:,1) < 400);
        f1temp1 = f1temp1 + 31*(mark2).*x(:,1);
        f1temp1 = f1temp1 + 100000*(1-mark1-mark2);

        mark3 = (x(:,2)>= 0) & (x(:,2) < 100);
        f2temp1 = 28*(mark3).*x(:,2);
        mark4 = (x(:,2)>= 100) & (x(:,2) < 200);
        f2temp1 = f2temp1 + 29*(mark4).*x(:,2);
        mark5 = (x(:,2)>= 200) & (x(:,2) < 1000);
        f2temp1 = f2temp1 + 30*(mark5).*x(:,2);
        f2temp1 = f2temp1 + 100000*(1-mark3-mark4-mark5);
        f = f1temp1+f2temp1;

        h(:,1)=-x(:,1)+300-(x(:,3).*x(:,4)./131.078).*cos(1.48477-x(:,6))+(x(:,3).^2*0.90789/131.078)*cos(1.47588);
        h(:,2)=-x(:,2)-(x(:,3).*x(:,4)/131.078).*cos(1.48477+x(:,6))+(x(:,4).^2*0.90789/131.078)*cos(1.47588);
        h(:,3)=-x(:,5)-(x(:,3).*x(:,4)/131.078).*sin(1.48477+x(:,6))+(0.90789*x(:,4).^2/131.078)*sin(1.47588);
        h(:,4)=200-(x(:,3).*x(:,4)/131.078).*sin(1.48477-x(:,6))+(0.90789*x(:,3).^2/131.078)*sin(1.47588);
        g = zeros(ps,1);


     end
    if(I_fno ==8)
    % g21
      f = x(:,1);
      g = -x(:,1) + 35.*x(:,2).^0.6 + 35.*x(:,3).^0.6;
      h(:,1)= -300*x(:,3)+7500*x(:,5)-7500*x(:,6)-25*x(:,4).*x(:,5)+25*x(:,4).*x(:,6)+x(:,3).*x(:,4);
      h(:,2)= 100*x(:,2)+155.365*x(:,4)+2500*x(:,7)-x(:,2).*x(:,4)-25*x(:,4).*x(:,7)-15536.5;
      h(:,3)= -x(:,5)+log(-x(:,4)+900);
      h(:,4)= -x(:,6)+log(x(:,4)+300);
      h(:,5)= -x(:,7)+log(-2*x(:,4)+700);

    end
    if(I_fno ==9)
    % g22
     f = x(:,1);
    g =  -x(:,1) + x(:,2).^0.6 + x(:,3).^0.6 + x(:,4).^0.6;
    fun1=x(:,5)-100000*x(:,8)+1*10^7;
        fun2=x(:,6)+100000*x(:,8)-100000*x(:,9);
        fun3=x(:,7)+100000*x(:,9)-5*10^7;
        fun4=x(:,5)+100000*x(:,10)-3.3*10^7;
        fun5=x(:,6)+100000*x(:,11)-4.4*10^7;
        fun6=x(:,7)+100000*x(:,12)-6.6*10^7;
        fun7=x(:,5)-120*x(:,2).*x(:,13);
        fun8=x(:,6)-120*x(:,3).*x(:,14);
        fun9=x(:,7)-120*x(:,4).*x(:,15);
        fun10=x(:,8)-x(:,11)+x(:,16);
        fun11=x(:,9)-x(:,12)+x(:,17);
        fun12=-x(:,18)+log(x(:,10)-100);
        fun13=-x(:,19)+log(-x(:,8)+300);
        fun14=-x(:,20)+log(x(:,16));
        fun15=-x(:,21)+log(-x(:,9)+400);
        fun16=-x(:,22)+log(x(:,17));
        fun17=-x(:,8)-x(:,10)+x(:,13).*x(:,18)-x(:,13).*x(:,19)+400;
        fun18=x(:,8)-x(:,9)-x(:,11)+x(:,14).*x(:,20)-x(:,14).*x(:,21)+400;
        fun19=x(:,9)-x(:,12)-4.60517*x(:,15)+x(:,15).*x(:,22)+100;
        h=[fun1,fun2,fun3,fun4,fun5,fun6,fun7,fun8,fun9,fun10,fun11,fun12,fun13,fun14,fun15,fun16,fun17,fun18,fun19];

    end
    if(I_fno ==10)
    %g23
      f = -9*x(:,5) - 15*x(:,8) + 6*x(:,1) + 16*x(:,2)+ 10*(x(:,6)+x(:,7));
    %   mark=(f==0);
    %   f = (mark.*100000)+((-mark).*f + f);

        g(:,1) = x(:,9).*x(:,3) + 0.02*x(:,6)- 0.025*x(:,5);
        g(:,2) = x(:,9).*x(:,4) + 0.02*x(:,7) - 0.015*x(:,8);
        h(:,1)=x(:,1)+x(:,2)-x(:,3)-x(:,4);
        h(:,2)=0.03*x(:,1)+0.01*x(:,2)-x(:,9).*(x(:,3)+x(:,4));
        h(:,3)=x(:,3)+x(:,6)-x(:,5);
        h(:,4)=x(:,4)+x(:,7)-x(:,8);
    end
      
 g = g';
 h = h';
