% The superiority of feasible solutions for constraint handling methods
function results=SF_DE(Prob_Set_Par, func_num_Par)
global  nfeval
format long e;

func_num = func_num_Par;    % Function Number
 NP       = 50;    % Size of Population
 Prob_Set = Prob_Set_Par;     
%  Max_FES  = [240000,240000,100000,200000,400000,400000,240000,240000];% Maximum number of function evaluations
 Max_FES  = [240000,240000,240000,240000,240000,240000,240000,240000,240000,240000, 240000,240000,240000,240000,480000,480000,240000,240000];
%  Max_FES  = [9*20000,11*20000,9*20000,6*20000,48*20000,38*20000];
 Max_FES  = Max_FES(func_num);
%  Max_FES=240000;%240000
 Max_Gen  = Max_FES/NP; %1200;  % Maximum number of generations
 max_run=25;
 best_known=[-1.0005001000  5126.4967140071   0.7499000000   0.0539415140  -47.7648884595 961.7150222899 8853.5396748064 193.7245100700 236.4309755040 -400.0551000000 ...
     189.311629686621  7.049036954314099e+03   -3.882595200000000e-01    -4.000055999999998e+02  1.863830408000000e+00 2.115862756945173e+00  2.5576545740E+00 9.9238463653e+01];
best_known=best_known(func_num);
Par     = Cal_par(Prob_Set ,func_num);
D       = Par.n;
g       = Par.g;
h       = Par.h;
Xmin    = Par.xmin;
Xmax    = Par.xmax;

for runs=1:max_run % Number of runs
    aa=0;
    fprintf('Run %d',runs);
    nfeval=0;
    %һʼȺ
    pop=repmat(Xmin,NP,1)+repmat((Xmax-Xmin),NP,1).*rand(NP,D);

    if (Prob_Set == 1)
             [val(:,1), g, h] = RWCOP(pop,func_num);
    else
             [val(:,1), g, h] = AVR_RWCOP(pop,func_num);
    end
    nfeval=nfeval+NP;
    ub=repmat(Xmax,NP,1);
    lb=repmat(Xmin,NP,1);
    CONV=abs(h);  %delta
    if(~isempty(CONV) & ~isempty(find(CONV>0)))
        DELTA=median(median(CONV,2));
        numD=10^(log10(DELTA/10^(-4))/600);
    else
        DELTA=10^(-4);
        numD=1;
    end
    rot=(0:1:NP-1);
    gen1=1;gen2=[];
    for gen=1:Max_Gen
        %Adaptation of delta for equality constraint
        if(gen==1)
            delta=DELTA;
        else
            delta=max(10^(-4),DELTA/(numD^gen));
        end
        FM_mui = rand(NP,D) < 0.9;
        FM_mpo = FM_mui < 0.5;
        ind=randperm(2);
        FVr_a1 = randperm(NP);
        rt=rem(rot+ind(1),NP);
        FVr_a2 = FVr_a1(rt+1);
        rt=rem(rot+ind(2),NP);
        FVr_a3 = FVr_a2(rt+1);
        
        newpop(1:NP,:)=pop(FVr_a1,:)+ 0.7*(pop(FVr_a2,:)-pop(FVr_a3,:));
        for i=1:NP  
            
            for kk=1:D
                if(newpop(i,kk) < Xmin(kk))
                    newpop(i,kk)= Xmin(kk)+( Xmax(kk)- Xmin(kk)).*rand;
                end
                if(newpop(i,kk) > Xmax(kk))
                    newpop(i,kk)= Xmin(kk)+( Xmax(kk)- Xmin(kk)).*rand;
                end
            end
        end
        newpop = pop.*FM_mpo + newpop.*FM_mui;

        if(Prob_Set == 1)
                 [newval(:,1),newg,newh]=RWCOP(newpop,func_num);
        else
                 [newval(:,1),newg,newh]=AVR_RWCOP(newpop,func_num);
       end
        nfeval=nfeval+NP;
        
        A=[];
        B=[];
        G=[];
        H=[];
        A=[pop;newpop];
        B=[val;newval];
        G=[g,newg];
        H=[h,newh];
        
        %Superiority of Feasible Solutions
         cons1=[(G>0).*G;((abs(H)-delta)>0).*(abs(H)-delta)]';
         cons_max1=max(cons1,[],1);
         nzindex1=find(cons_max1~=0);
         
         if isempty(nzindex1)
             tcons1=zeros(size(A,1),1);
%              tcons11=zeros(size(A,1),1);
         else
             tcons1=sum(cons1(:,nzindex1)./repmat(cons_max1(:,nzindex1),size(A,1),1),2)./sum(1./cons_max1(:,nzindex1));
%              tcons1=sum(cons1(:,nzindex1),2)./(Par.g + Par.h);
         end
         

         for kk=1:NP %ѰŸ
             if((tcons1(NP+kk)<tcons1(kk)) | ((tcons1(NP+kk)==0) & (tcons1(kk)==0) & (B(NP+kk)<=B(kk))))
                 pop(kk,:)= A(NP+kk,:);
                 val(kk,:)= B(NP+kk,:);
                 g(:,kk)  = G(:,NP+kk);
                 h(:,kk)  = H(:,NP+kk);
             end
         end
        
        totalpop=pop;
        totalval=val;
        totalg=g;
        totalh=h;
        cons5=[(totalg>0).*totalg;((abs(totalh)-10^(-4))>0).*(abs(totalh)-10^(-4))]';
        cons_max5=max(cons5,[],1);
        nzindex5=find(cons_max5~=0);
        
        if isempty(nzindex5)
            tcons5=zeros(NP,1);
%             tcons51=zeros(NP,1);
        else
            tcons5=sum(cons5(:,nzindex5)./repmat(cons_max5(:,nzindex5),NP,1),2)./sum(1./cons_max5(:,nzindex5));
%             tcons5=sum(cons5(:,nzindex5), 2)./(Par.g + Par.h);
        end
        
      
        feasindex=find(tcons5==0);
        if isempty(feasindex)
            [gbesttcons,ibest]=min(tcons5);
%             [fcons, ibest1] = min(tcons51);
            gbestval=totalval(ibest);
            gbest = totalpop(ibest,:);
        else
            [gbestval,ibest]=min(totalval(feasindex));
            gbesttcons=tcons5(feasindex(ibest));
%             fcons = tcons51(feasindex(ibest));
            gbest = totalpop(feasindex(ibest),:);
        end
        
        if(gen ==1)
            thegbestval = gbestval;
            thegbesttcons = gbesttcons;
            thegbest(runs,:) = gbest;
        elseif((gbesttcons < thegbesttcons) | (gbesttcons==0 & thegbesttcons ==0 & gbestval < thegbestval))
            thegbestval = gbestval;
            thegbesttcons = gbesttcons;
            thegbest(runs,:) = gbest;
        end
        
        W(gen,1)=thegbestval;
        W(gen,2)=thegbesttcons;
        W(gen,3)=nfeval;
        if gen==1||mod(W(gen,3),Max_FES/20)==0
        aa=aa+1;
        W1(aa,1)=W(gen,1);
        W1(aa,2)=W(gen,3);
        end
        
    end
    plot(W1(:,2),W1(:,1),'-*')
    fr=find(W(:,2)==0);
    if ~isempty(fr)
        FR(runs,:)=1;
    else
        FR(runs,:)=0;
    end
    [row1,~]=find(W(:,2)==0);
    [sr,~]=find(abs(W(row1,1)-best_known)<abs(0.01*best_known));
    if ~isempty(sr)
        SR(runs,:)=1;
        FES(runs,:)=W(row1(sr(1)),3);
        FES2(runs,:)=length(sr);
        plot(W1(:,2),W1(:,1),'-*')
    else
        SR(runs,:)=0;
        FES(runs,:)=NaN;
        FES2(runs,:)=NaN;
    end

    Re(runs,1)=thegbestval;
    Re(runs,2)=thegbesttcons;
    
end
FES(isnan(FES))=[];
FES2(isnan(FES2))=[];
FES1=sum(FES,1)/sum(SR,1);%reach
FES3=sum(FES2,1)/sum(SR,1);%mean
FR=100*length(find(FR==1))/max_run;
SR=100*length(find(SR==1))/max_run;
a = find(Re(:,2)==0);
sort_of_solution = [];
if ~isempty(a)
    [~,index11] = sort(abs(Re(a,1)-best_known));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(a(index11(i)), 1), Re(a(index11(i)), 2)];
    end
    Re(a,:) = [];
else
    [~,index11] = sort(Re(:,2));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(index11(i), 1), Re(index11(i), 2)];
    end
    Re = [];
end
if ~isempty(Re)
    [~,index11] = sort(Re(:,2));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(index11(i), 1), Re(index11(i), 2)];
    end
end
Res(1, :) = sort_of_solution(1, 1);
sta_of_vio(1, :) = sort_of_solution(1, 2);
Res(2,:)=median(sort_of_solution(:,1));
sta_of_vio(2, :) = median(sort_of_solution(:,2));
Res(3,:)=mean(sort_of_solution(:,1));
sta_of_vio(3, :) = mean(sort_of_solution(:,2));
Res(4,:)=sort_of_solution(end,1);
sta_of_vio(4, :) = sort_of_solution(end,2);
Res(5,:)=std(sort_of_solution(:,1));
sta_of_vio(5, :) = std(sort_of_solution(:,2));
results=[Res', sta_of_vio', FR, SR];





