% Main routine for running the CMA-ES variants on the 2006 CEC Benchmarks
clear all,clc,close all
for Prob_Set=1 %1:without AVRA;2:with AVRA
    display(['Prob_Set=',num2str(Prob_Set)]);
    results = zeros(18,12);
for k=13
    display(['Prob=',num2str(k)]);
        func_num=k;
        Par     = Cal_par(Prob_Set ,func_num);
        global  initial_flag
        initial_flag = 0;

        % choose the problem dimensionality
        D= Par.n;
        Xmin=Par.xmin;
        Xmax=Par.xmax;
         best_known=[-1.0005001000  5126.4967140071   0.7499000000   0.0539415140  -47.7648884595 961.7150222899 8853.5396748064 193.7245100700 236.4309755040 -400.0551000000 ...
            189.311629686621  7.049036954314099e+03   -3.882595200000000e-01    -4.000055999999998e+02  1.863830408000000e+00 2.115862756945173e+00  2.5576545740E+00 9.9238463653e+01];
       best_known=best_known(func_num);
        
        g       = Par.g;
        h       = Par.h;
        % number of constraint functions per problem

        problem.gn=g;
        problem.hn=h;

        % budget of function evaluations and generations depending on dimension D
        Par1     = Cal_par(1,func_num);
        D1= Par1.n;
        if func_num == 15 || func_num == 16
            MaxFES=480000;
            MaxGEN=48000;
        else
            MaxFES=100000;
            MaxGEN=10000;
        end


        % input -- initial (fixed) strategy parameter setting
        input.budget            = MaxFES;
        input.maxIter           = MaxGEN;
        input.delta             = 10^-4;                    % error margin for equality constraints
        input.runs              = 25;                       % number of repetitions
        input.dim               = D;


        % CMA specific paprameters
        input.lambda            = 4*D;                          % population size
        input.sigma             = 1;                            % initial mutation strength
        input.mu                = floor(input.lambda/3);        % parental ppopulation size
        input.weights = log(input.mu+1/2)-log(1:input.mu)';     % muXone array for weighted recombination
        input.weights = input.weights./sum(input.weights);      % normalize recombination weights array
        input.mueff=1/sum(input.weights.^2);                    % variance-effectiveness of sum w_i x_i
        input.cs = (input.mueff+2) / (D+input.mueff+5);         % t-const for cumulation for sigma control
        input.c1 = 2 / ((D+1.3)^2+input.mueff);                 % learning rate for rank-one update of M
        input.cmu = min(1-input.c1, 2 * (input.mueff-2+1/input.mueff) / ((D+2)^2+input.mueff));     % and for rank-mu update of M
        input.damps = 1 + 2*max(0, sqrt((input.mueff-1)/(D+1))-1) + input.cs;                       % damping for sigma usually close to 1

        if Prob_Set==1
        problem.constr_fun_name = 'TEC';                    % objective function class
        else
            problem.constr_fun_name = 'TEC_reductionn'; 
        end

        strategy='epsMAgES';                                    % algorithm variant
%         foldername = ['CEC2018_RS_' strategy];
%         efn = exist(foldername);
%         if efn ~= 7
%             mkdir(foldername);
%         end

        disp(['ES variant ' strategy ' --- 25 independent runs!'])

                                                 % on each CEC 2018 test function do
                                                     % test function number
            initial_flag = 0;

            eval(['input.lb=Xmin' ';']);
            eval(['input.ub=Xmax' ';' ]);

            problem.upper_bounds    = input.ub';
            problem.lower_bounds    = input.lb';

tic
            for j=1:input.runs                                  % perform multiple runs on each test function
                aa=0;
                [out,global_best,W,W2]=epsMAgES(problem,input,func_num);
%                 eval(['[tab]=' strategy '(problem,input,func_num);']); % run epsMAgES
%                 FitT(j,:)=[tab(1,:) tab(2,:) tab(3,:)];
                Re(j,1)=global_best.val;
                Re(j,2)=global_best.conv;
                fevs(j,:)=global_best.fevs;
%                 W=W(1:MaxFES,:);
%                 for i=1:size(W,1)
%                 if i==1||mod(i,5000)==0
%                 aa=aa+1;
%                 W1(aa,1)=W(i,1);
%                 W1(aa,2)=W(i,3);
%                 end
%                 end 
                for i=1:size(W2,1)
                if i==1||mod(i,floor(size(W2,1)/20))==0
                aa=aa+1;
                W1(aa,1)=W2(i,1);
                W1(aa,2)=W2(i,3);
                end
                end 
                plot(W1(:,2),W1(:,1),'-*')
                fr=find(W(:,2)==0);
    if ~isempty(fr)
        FR(j,:)=1;
    else
        FR(j,:)=0;
    end
    [row1,~]=find(W(:,2)==0);
    [sr,~]=find(abs(W(row1,1)-best_known)<abs(0.01*best_known));
    if ~isempty(sr)
        SR(j,:)=1;
        FES(j,:)=W(row1(sr(1)),3);
        FES2(j,:)=length(sr);
     plot(W1(:,2),W1(:,1),'-*')
    else
        SR(j,:)=0;
        FES(j,:)=NaN;
        FES2(j,:)=NaN;
    end
    disp(['run=',int2str(j)]);
    toc
            end

 FES(isnan(FES))=[];
FES2(isnan(FES2))=[];
FES1=sum(FES,1)/sum(SR,1);%reach
FES3=sum(FES2,1)/sum(SR,1);%mean
FR=100*length(find(FR==1))/input.runs;
SR=100*length(find(SR==1))/input.runs;
a = find(Re(:,2)==0);
sort_of_solution = [];
if ~isempty(a)
    [~,index11] = sort(abs(Re(a,1)-best_known));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(a(index11(i)), 1), Re(a(index11(i)), 2)];
    end
    Re(a,:) = [];
else
    [~,index11] = sort(Re(:,2));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(index11(i), 1), Re(index11(i), 2)];
    end
    Re = [];
end
if ~isempty(Re)
    [~,index11] = sort(Re(:,2));
    for i = 1:length(index11)
        sort_of_solution = [sort_of_solution; Re(index11(i), 1), Re(index11(i), 2)];
    end
end
Res(1, :) = sort_of_solution(1, 1);
sta_of_vio(1, :) = sort_of_solution(1, 2);
Res(2,:)=median(sort_of_solution(:,1));
sta_of_vio(2, :) = median(sort_of_solution(:,2));
Res(3,:)=mean(sort_of_solution(:,1));
sta_of_vio(3, :) = mean(sort_of_solution(:,2));
Res(4,:)=sort_of_solution(end,1);
sta_of_vio(4, :) = sort_of_solution(end,2);
Res(5,:)=std(sort_of_solution(:,1));
sta_of_vio(5, :) = std(sort_of_solution(:,2));
results=[Res', sta_of_vio', FR, SR];

end
 
end
        


