function [out,global_best,W,W2]=epsMAgES(problem,input,CEC_fun_no)
    W=[];
    dim         = length(problem.lower_bounds);
    sigma       = input.sigma;
    mu          = input.mu;
    lambda      = input.lambda;
    newpop.y    = zeros(dim,lambda);    % initialize new population matrix (n times NP)
	newpop.f    = 0;
	newpop.conv = 0;
	evals.fun   = 0;

    g           = 0;
    termination = 0;
    
    % Initialize dynamic (internal) strategy parameters and constants
    ps      = zeros(dim,1);                                 % evolution paths for sigma
    MM      = eye(dim);                                     % initial transformation matrix
    sqrt_s  = sqrt(input.cs*(2-input.cs)*input.mueff);      % factor in path update
      
    constraint_number = problem.gn + problem.hn;
    % Initialize random population of lambda candidate solutions
    for k=1:lambda
        newpop.y(:,k)   = problem.lower_bounds...
                            +(problem.upper_bounds-problem.lower_bounds).*rand(dim,1);
           if CEC_fun_no==4 && input.dim==3
                h1 = nthroot((-newpop.y(1,k).^3 -1),3);%x2
                h2=(h1.*newpop.y(2,k))./(5*newpop.y(3,k));%x3
            while h1<-2.3 || h1>2.3 ||h2<-3.2 ||h2>3.2
                newpop.y(:,k)   = problem.lower_bounds...
                            +(problem.upper_bounds-problem.lower_bounds).*rand(dim,1); 
                h1 = nthroot((-newpop.y(1,k).^3 -1),3);%x2
                h2=(h1.*newpop.y(2,k))./(5*newpop.y(3,k));%x3
            end
            end
         

        if CEC_fun_no==2 && input.dim==1
            while (sin(newpop.y(:,k)-0.25) + 3237/2500)>1
                newpop.y(:,k)   = problem.lower_bounds...
                            +(problem.upper_bounds-problem.lower_bounds).*rand(dim,1); 
            end
        end

         if CEC_fun_no==7&&input.dim==2
             x_3=newpop.y(1,k);x_6=newpop.y(2,k);
             x_4=-(65539*((162814751511899196309*x_3.^2)./23612913278258794987520 + 200))./(500*x_3.*sin(x_6 - 6686809618730891/4503599627370496));%x4[340,420]
             x_1=(310007085404318773749*x_3.^2)/472258265565175899750400 - (500*x_3.*x_4.*cos(x_6 - 6686809618730891/4503599627370496))/65539 + 300;%x1[0,400]
             while x_1<0||x_1>400 ||x_4<340||x_1>420
                 newpop.y(:,k)   = problem.lower_bounds...
                            +(problem.upper_bounds-problem.lower_bounds).*rand(dim,1);
                 x_3=newpop.y(1,k);x_6=newpop.y(2,k);
                 x_4=-(65539*((162814751511899196309*x_3.^2)./23612913278258794987520 + 200))./(500*x_3.*sin(x_6 - 6686809618730891/4503599627370496));%x4[340,420]
                 x_1=(310007085404318773749*x_3.^2)/472258265565175899750400 - (500*x_3.*x_4.*cos(x_6 - 6686809618730891/4503599627370496))/65539 + 300;%x1[0,400]
             end
         end
         
        [fval, gv, hv]  = feval(problem.constr_fun_name,newpop.y(:,k)',CEC_fun_no);
        newpop.f(k)     = fval;                             % fitness vector 
        newpop.conv(k)  = sum([sum(gv.*(gv>0)), sum(abs(hv).*(abs(hv)>input.delta))])./constraint_number;  % mean constraint violations)
%         cons1=[(gv>0).*gv;((abs(hv)-input.delta)>0).*(abs(hv)-input.delta)]';
%                     cons_max1=max(cons1,[],1);
%                     nzindex1=find(cons_max1~=0);
%                     if isempty(nzindex1)
%                         newpop.conv(k) =zeros(1,1);
%                     else
%                         newpop.conv(k) =sum(cons1(:,nzindex1)./repmat(cons_max1(:,nzindex1),1),1,2)./sum(1./cons_max1(:,nzindex1));
%                     end
		evals.fun       = evals.fun + 1;                    % count objective function evaluations
        W(evals.fun,1)=newpop.f(k);
        W(evals.fun,2)=newpop.conv(k);
        W(evals.fun,3)=evals.fun;
    end

    % Initial parameter for epsilon level ordering
    TC=1000;                                                
    n=ceil(0.9*size(newpop.conv,2));                        
    index=eps_sort(newpop.f,newpop.conv,0);
    EPSILON=mean(newpop.conv(index(1:n)));                  
    Epsilon= EPSILON;
    CP=max(3,(-5-log(EPSILON))/log(0.05));                  
    
    % Rank initial population 
    [ranking]           = eps_sort(newpop.f,newpop.conv,Epsilon);   % epsilon Ranking
    ParentPop           = newpop.y(:,ranking(1:mu));
    yParent             = sum(ParentPop,2)./mu;
    
    % Best individual of current population
    best_ind            = ranking(1);
    best_val            = newpop.f(best_ind);       % best fitness value of current population
    best_y              = newpop.y(:,best_ind);
    best_conv           = newpop.conv(:,best_ind);
          
    % Best solution found so far
    global_best.y       = best_y; 				% best solution found so far
	global_best.val     = best_val;
    global_best.conv    = best_conv;
    
    % Upper mutation strength bound
    sigmaMAX            = 100;
    flag1               = 0;
    flag2               = 0;
    
    while ~termination
        % Compute pseudo inverse of transformation matrix MM
        if MM==Inf
            MM=1;
            piM  = pinv(MM,1e-12);
        else
            piM = pinv(MM,1e-12);
        end
        repi      = zeros(1,lambda);  
        
        
        % Sample lambda offspring distributed around yParent
        newpop.z  = randn(dim,lambda);
        newpop.d  = MM*newpop.z;
        newpopy   = repmat(yParent,1,lambda) + sigma.*newpop.d;
        
        for k=1:lambda 
                                        
            % ensure box constraint satisfaction 
            newpop.y(:,k)   = keep_range(newpopy(:,k),problem.lower_bounds,problem.upper_bounds);

            if CEC_fun_no==7&&input.dim==2
             x_3=newpop.y(1,k);x_6=newpop.y(2,k);
             x_4=-(65539*((162814751511899196309*x_3.^2)./23612913278258794987520 + 200))./(500*x_3.*sin(x_6 - 6686809618730891/4503599627370496));%x4[340,420]
             x_1=(310007085404318773749*x_3.^2)/472258265565175899750400 - (500*x_3.*x_4.*cos(x_6 - 6686809618730891/4503599627370496))/65539 + 300;%x1[0,400]
             while x_1<0||x_1>400
                 newpop.y(:,k)   = problem.lower_bounds...
                            +(problem.upper_bounds-problem.lower_bounds).*rand(dim,1);
                 x_3=newpop.y(1,k);x_6=newpop.y(2,k);
                 x_4=-(65539*((162814751511899196309*x_3.^2)./23612913278258794987520 + 200))./(500*x_3.*sin(x_6 - 6686809618730891/4503599627370496));%x4[340,420]
                 x_1=(310007085404318773749*x_3.^2)/472258265565175899750400 - (500*x_3.*x_4.*cos(x_6 - 6686809618730891/4503599627370496))/65539 + 300;%x1[0,400]
             end
            end
            if CEC_fun_no==4 && input.dim==3
                h1 = nthroot((-newpop.y(1,k).^3 -1),3);%x2
                h2=(h1.*newpop.y(2,k))./(5*newpop.y(3,k));%x3
            while h1<-2.3 || h1>2.3 ||h2<-3.2 ||h2>3.2
                newpop.y(:,k)   = problem.lower_bounds...
                            +(problem.upper_bounds-problem.lower_bounds).*rand(dim,1); 
                h1 = nthroot((-newpop.y(1,k).^3 -1),3);%x2
                h2=(h1.*newpop.y(2,k))./(5*newpop.y(3,k));%x3
            end
            end
            % log whether an offspring was repaired
            repi(k) = (sum(newpop.y(:,k)~=newpopy(:,k)) > 0);
            % evaluation  
            [fval, gv, hv]  = feval(problem.constr_fun_name,newpop.y(:,k)',CEC_fun_no);
            evals.fun       = evals.fun + 1;
            fitval          = fval;                                                                 % fitness vector 
            convio          = sum([sum(gv.*(gv>0)), sum(abs(hv).*(abs(hv)>input.delta))])./(problem.gn + problem.hn);                  % vector of the corresponding constraint violations)
%             cons1=[(gv>0).*gv;((abs(hv)-input.delta)>0).*(abs(hv)-input.delta)]';
%                     cons_max1=max(cons1,[],1);
%                     nzindex1=find(cons_max1~=0);
%                     if isempty(nzindex1)
%                         convio =zeros(1,1);
%                     else
%                         convio =sum(cons1(:,nzindex1)./repmat(cons_max1(:,nzindex1),1,1),2)./sum(1./cons_max1(:,nzindex1));
%                     end
            if isnan(convio)
                convio=10000;
            end
            W(evals.fun,1)=fitval;
            W(evals.fun,2)=convio;
            W(evals.fun,3)=evals.fun;
            h=1;            
            % gradient-based repair step
            if mod(g,dim)==0 && rand(1) <=0.2
                while convio > 0 && h <= 3
                    new_mutant      = gradientMutation(problem,newpop.y(:,k),gv,hv,CEC_fun_no);
                    new_mutant      = keep_range(new_mutant,problem.lower_bounds,problem.upper_bounds);
                    [fval, gv, hv]  = feval(problem.constr_fun_name,new_mutant',CEC_fun_no);
                    fitval          = fval;                                                                 % fitness vector 
%                     cons1=[(gv>0).*gv;((abs(hv)-input.delta)>0).*(abs(hv)-input.delta)]';
%                     cons_max1=max(cons1,[],1);
%                     nzindex1=find(cons_max1~=0);
%                     if isempty(nzindex1)
%                         convio =zeros(1,1);
%                     else
%                         convio =sum(cons1(:,nzindex1)./repmat(cons_max1(:,nzindex1),1,1),2)./sum(1./cons_max1(:,nzindex1));
%                     end
                    convio = sum([sum(gv.*(gv>0)), sum((abs(hv)-input.delta).*(abs(hv)>input.delta))])./(problem.gn + problem.hn);
                    if isnan(convio)
                    convio=10000;
                    end

                    evals.fun       = evals.fun + dim + 1;     % count function evaluations
                    W((evals.fun-dim):evals.fun,1)=fitval;
                    W((evals.fun-dim):evals.fun,2)=convio;
                    W((evals.fun-dim):evals.fun,3)=evals.fun;
                    if evals.fun>=input.budget              % check termination criterion
                        out = global_best.val;
                        break
                    end

                    h=h+1;
                    newpop.y(:,k) = new_mutant;
                    repi(k)= repi(k)+1;                     % log repaired offspring individuals
               end 
            end
            newpop.f(k)     = fitval;                                                                 % fitness vector 
            newpop.conv(k)  = convio;
            
            % Readjust mutation vectors:
            % iff repaired or components adjusted w.r.t box constraints
            if repi(k) > 0
                newpop.d(:,k) = (newpop.y(:,k)    - yParent)./sigma;
                newpop.z(:,k) = piM*newpop.d(:,k);
            end
        end
           
        % Rank current population w.r.t. recent epsilon level        
        [ranking]   = eps_sort(newpop.f,newpop.conv,Epsilon);
        
        % Best individual of current population
        best_ind    = ranking(1);
        best_val    = newpop.f(best_ind);            
        best_y      = newpop.y(:,best_ind);          
        best_conv   = newpop.conv(:,best_ind);
        
        % Recombination of mutation vectors and centroid update
        parent_z = newpop.z(:,ranking(1:mu)) * input.weights;  
        parent_d = newpop.d(:,ranking(1:mu)) * input.weights;  
        yParent  = yParent + sigma * parent_d; 
                        
        % Update evolution path and transformation matrix
        ps = (1-input.cs) * ps + sqrt_s * parent_z; 
        MM = (1 - 0.5*input.c1 - 0.5*input.cmu) * MM + (0.5*input.c1)*(MM*ps)*ps';
        for m = 1:mu
            MM = MM + ((0.5*input.cmu*input.weights(m))*newpop.d(:,ranking(m)))...
                *newpop.z(:,ranking(m))';
        end    
        
        % Regularization step to prevent unstable pseudo inverse calculations
        liMM = MM > 1e+12;
        siMM = MM < -1e+12;
        if sum(sum(liMM))>1 || sum(sum(siMM))>1
            MM = eye(input.dim);
        end
        
        % Adapt the mutation strength 
        sigma = min(sigma  * exp((input.cs/2)*(norm(ps)^2/input.dim - 1)),sigmaMAX); 
       
        % update best solution found so far                    
        if (best_conv==0 && global_best.conv==0 && best_val <= global_best.val) ||...
                (best_conv==global_best.conv && best_val <= global_best.val) || best_conv<global_best.conv
            global_best.y   = best_y; 				
            global_best.val = best_val;
            global_best.conv = best_conv;
            global_best.fevs = evals.fun;
        end

        if evals.fun>=input.budget                      % check termination criterion
            termination = 1;
            
        end
         
        % Update epsilon value 
        g=g+1;
        if(g>1 && g<TC)
          Epsilon=EPSILON*((1-g/TC)^CP);
        elseif(g+1>=TC)
          Epsilon=0;
        end   
        
     % log global best after having used 10%, and 50% of the evaluation budget
        if evals.fun>=input.budget*10/100 && flag1==0
            fit10=global_best.val;
            con10=global_best.conv;
            [ff,gg,hh]=feval(problem.constr_fun_name,global_best.y',CEC_fun_no);
            c10_1    = sum(gg>1)                  + sum(abs(hh)>1);
            c10_2    = sum((gg>0.01) & (gg<1))    + sum(abs(hh)>0.01 & abs(hh)<1);
            c10_3    = sum((gg>0.0001)&(gg<0.01)) + sum(abs(hh)>0.0001 & abs(hh)<0.01);  
            flag1=1;
        elseif evals.fun>=input.budget*50/100 && flag2==0
            fit50=global_best.val;
            con50=global_best.conv;
            [ff,gg,hh]=feval(problem.constr_fun_name,global_best.y',CEC_fun_no);
            c50_1    = sum(gg>1)                  + sum(abs(hh)>1);
            c50_2    = sum((gg>0.01)&(gg<1))      + sum(abs(hh)>0.01 & abs(hh)<1);
            c50_3    = sum((gg>0.0001)&(gg<0.01)) + sum(abs(hh)>0.0001 & abs(hh)<0.01)  ;
            flag2=1;
        end
        
        W2(g,1)=global_best.val;
        W2(g,2)=global_best.conv;
        W2(g,3)=evals.fun;

    end
    
    % log final global best solution
    fit100=global_best.val;
    con100=global_best.conv;
    [ff,gg,hh]=feval(problem.constr_fun_name,global_best.y',CEC_fun_no);
    c100_1    = sum(gg>1)                   + sum(abs(hh)>1);
    c100_2    = sum((gg>0.01)&(gg<1))       + sum(abs(hh)>0.01 & abs(hh)<1);
    c100_3    = sum((gg>0.0001)&(gg<0.01))  + sum(abs(hh)>0.0001 &abs(hh)<0.01);
   
    out = [fit10 con10 c10_1 c10_2 c10_3;
             fit50 con50 c50_1 c50_2 c50_3;
             fit100 con100 c100_1 c100_2 c100_3];
    
end
