%% MONES: Multiobjective Optimization for Nonlinear Equation Systems
% Developed by Yong Wang
% Email: ywang@csu.edu.cn

% clc;
clear all;
close all;

disp([' --------------------------------------------------------------------------- ']);
disp(['                                    MONES                                    ']);
disp([' --------------------------------------------------------------------------- ']);


format long;
format compact;

problem_set = [1 :46];

for problem_index = 46
    
    tic;
    
    problem = problem_set(problem_index);
    
    time = 1;
    totalTime = 30;
  
    % popsize  the population size
    popsize = 100;
    
    finalSolutions = [];
    finalFit = [];
    
    gama = 1;
    
    IGD = zeros(totalTime, 21);
    NOF = zeros(totalTime, 1);
    kesi = 10^-5;
    while time <= totalTime
        max_gen=500;
        switch problem
            
            case 1
                
                n = 2;
                m = 2;
                lu = [ -3 * ones(1, n); 3*ones(1, n)];
                max_gen = 100;
                
            case 2
                
                n = 2;
                m = 2;
                lu = [ -3 * ones(1, n); 3*ones(1, n)];
                max_gen=500;
            case 3
                
                n = 3;
                m = 2;
                lu = [0 * ones(1, n); 50*ones(1, n)];
                max_gen = 1000;
                
            case 4
                
                n = 2;
                m = 2;
                lu = [ -3 * ones(1, n); 3*ones(1, n)];
                max_gen=200;
            
            case 5
                n=2;
               max_gen=100;
               m=2;
               lu = [ -3 * ones(1, n); 3*ones(1, n)];
                
            case 6
                
                n = 3;
                m=2;
                lu = [ 0 * ones(1, n); ones(1, n)];
                max_gen=500;
            case 7
                
                n = 2;
                
                m = 2;
                max_gen=500;
                lu = [ -1 * ones(1, n); 2*ones(1, n)];
                
                case 8
                
                n = 2;
                max_gen=500;
                m = 2;
                
                lu = [ -1 * ones(1, n); ones(1, n)];
            case 9
                n=20;
                m=2;
                lu = [ -1 * ones(1, n); ones(1, n)];
                max_gen=500;
            case 10
                n=2;
                m=2;
                lu = [ -1 * ones(1, n); ones(1, n)];
                max_gen=500;
            case 11
                n = 2;
                m = 2;
                lu = [ -1 * ones(1, n); ones(1, n)];
                max_gen=500;
                
            case 12
                 n=2;
               max_gen=500;
               m=2;
               lu = [ -10 * ones(1, n); 10*ones(1, n)];
               
              
            case 13
                n = 10;
                m = 2;
                lu = [ -2 * ones(1, n); 2*ones(1, n)];
                max_gen=500;
            case 14
                n = 2;
                m = 2;
                lu = [ -1 * ones(1, n); ones(1, n)];
                max_gen=500;
            case 15
                n = 4;
                m = 2;
                lu = [ 0 * ones(1, n); 5*ones(1, n)];
                max_gen=500;
            case 16
                n = 2;
                m = 2;
                lu = [ 0 * ones(1, n); ones(1, n)];
                max_gen=500;
            case 17
                n = 5;
                m = 2;
                lu = [ -10 * ones(1, n); 10*ones(1, n)];
                max_gen = 1000;
            case 18
                n = 6;
                m = 2;
                max_gen=500;
                lu = [ -1 * ones(1, n); ones(1, n)];
            case 19
                n = 2;
                m = 2;
                lu = [ -2 * ones(1, n); 2*ones(1, n)];
                max_gen=500;
            case 20
                 n = 2;
                m = 2;
                lu = [ -5 * ones(1, n); 5*ones(1, n)];
                max_gen=500;
            case 21
                n=2;
               max_gen=500;
               m=2;
               lu = [0 * ones(1, n); 2*pi*ones(1, n)];
               
            case 22
                n = 8;
                m = 2;
                lu = [ -1 * ones(1, n); ones(1, n)];
                max_gen = 1000;
            case 23
                n = 2;
                m = 2;
                lu = [ -2 * ones(1, n); 2*ones(1, n)];
            case 24
                n = 20;
                m = 2;
                lu = [ -2 * ones(1, n); 2*ones(1, n)];
                max_gen = 2000;
            case 25
                n = 3;
                m = 2;
                lu = [ -1 * ones(1, n); ones(1, n)];
                max_gen=500;
            case 26
                n = 2;
                m = 2;
                lu = [ -2 * ones(1, n); 2*ones(1, n)];
                max_gen=500;
            case 27
                n = 2;
                m = 2;
                lu = [ -2 * ones(1, n); 2*ones(1, n)];
            case 28
                n = 3;
                m = 2;
                lu = [ 0 * ones(1, n); ones(1, n)];
                max_gen = 1000;
            case 29
                n = 3;
                m = 2;
                lu = [ -5,-1,-5;5,3,5];
            case 30
                n = 3;
                m = 2;
                lu = [ -0.6,-0.6,-2;0.6,0.6,5];
            case 31
                n = 2;
                m = 2;
                lu = [ 0,-10;1,0];
            case 32
                n = 2;
                m = 2;
                lu = [ 0,-4;2.5,6];
            case 33
                n = 2;
                m = 2;
                lu = [ -1,-10;1,10];
            case 34
                n = 2;
                m = 2;
                lu = [ 0.25,1.5;1,2*pi];
            case 35
                n = 3;
                m = 2;
                lu = [ 3,2,0.5;5,4,2];
            case 36
                n = 2;
                m = 2;
                lu = [ -1,-2;-0.1,2];
            case 37
                n = 3;
                m = 2;
                lu = [ 1,0.2,0.1;2.5,2,3];
            case 38
                n = 2;
                m = 2;
                lu = [ -5,0;1.5,5];
            case 39
                n = 2;
                m = 2;
                lu = [ 0,10;2,30];
            case 40
                n = 3;
                m = 2;
                lu = [ 0,-10,-1;2,10,1];
            case 41
                n = 2;
                m = 2;
                lu = [ -2,0;2,1.1];
            case 42
                n = 2;
                m = 2;
                lu = [0.25,1.5;1,2*pi];
            case 43
                n = 5;
                m = 2;
                lu = [0 0 -1 -1 0;1 60 1 1 1];
                max_gen = 2000;
            case 44
                n = 6;
                m = 2;
                lu = [-10 -10 -10 -10 -10 -10;10 10 10 10 10 10];
                max_gen = 2000;
            case 45
                n = 10;
                m = 2;
                lu = [-1 -1 -1 -1 -1 -1 -1 -1 -1 -1;1 1 1 1 1 1 1 1 1 1];
                max_gen = 2000;
            case 46
                n = 5;
                m = 2;
                lu = [-10 -10 -10 -10 -10;10 10 10 10 10];
                max_gen = 2000;
                
        end
        
        % pcrossover  the crossover probability
        pcrossover = 0.9;
        
        % pmutation  the mutation probability
        pmutation = 1/n;
        
        % di  the distribution indexes for crossover
        di = 20;
        
        % dim  the distribution indexes for mutation
        dim = 20;
        
        rand('seed', sum(100*clock));
        
        % Generate an initial population
        x = ones(2 * popsize, 1) * lu(1, :) + rand(2 * popsize, n) .* (ones(2 * popsize, 1) * (lu(2, :) - lu(1, :)));
        
        % Evaluate each individual in the population
            fit = fitnessMONES(x, problem, n, gama);

        
        % Nondominated sorting
        [x, fit_v] = nondominated_sorting_and_selection(x, fit, popsize, m);
        fit = fit_v(:, 1 : m);
        
        % Generation number
        gen = 0;
        
        % The main body
        while gen <= max_gen
            
            % Implement binary tournament selection
            pool_size = popsize;
            mate_pool_chromosome = tournament_selection(x, fit_v, pool_size, n, m, popsize);
            
            % Implement simulated binary crossover and polynomial mutation to generate the offspring population
            offspring_chromosome = genetic_operator(mate_pool_chromosome, pool_size, n, lu, pcrossover, pmutation, di, dim);
            
            % Evaluate the offspring 
            fit_offspring = fitnessMONES(offspring_chromosome, problem, n, gama);
            
            x_offspring = offspring_chromosome(:, 1 : n);
            
            % Parent population + offspring population
            x((popsize + 1 : 2 * popsize), :) = x_offspring;
            fit((popsize + 1 : 2 * popsize), :) = fit_offspring;
            
            % Nondominated sorting
            [x, fit_v] = nondominated_sorting_and_selection(x, fit, popsize, m);
            fit = fit_v(:, 1 : m);
            
           % IGD indicator
            if mod(gen, fix(max_gen/20))==0 || gen == 0
                x_total=fitnessMONES(x, problem, n,gama);
                optimalFit = OP(problem, gama);
                [Rfit, ~] = size(optimalFit);
                for i = 1 : Rfit
                    if problem_index<=42
                        IGD(time, floor(gen/fix(max_gen/20))+1) = IGD(time, floor(gen/fix(max_gen/20))+1) + ...
                        min(sum((repmat(optimalFit(i, :), popsize, 1) - x).^2, 2).^0.5);
                    else
                        IGD(time, floor(gen/(max_gen/20))+1) = IGD(time, floor(gen/(max_gen/20))+1) + ...
                        min(sum((repmat(optimalFit(i, :), popsize, 1) - x_total).^2, 2).^0.5);
                    end
                    
                end
                IGD(time, floor(gen/fix(max_gen/20))+1) = IGD(time, floor(gen/fix(max_gen/20))+1) / Rfit;
           end
            
            gen = gen + 1;
            
        end
        
        % Compute the number of optima found (NOF)
        fitMONES = fitnessMONES(x, problem, n, gama);
        x_total =x;
        if problem_index>42
            x=fitnessMONES(x, problem, n,gama);
        end
        [optimalFit, A] = OP(problem, gama);
        [Rfit, ~] = size(optimalFit);     
        alfa = 0.01;
        a=0;qr=[];
        for i = 1 : Rfit
            if problem_index<=42
                [~, index] = min(sum((repmat(A(i,2:end), size(x,1), 1) - x).^2, 2).^0.5);
                k = Equations(x(index,:), problem_index);
            else
                [~, index] = min(sum((repmat(optimalFit(i, :), size(x,1), 1) - x).^2, 2).^0.5);
                k = Equations(x_total(index,:), problem_index)
            end
            if k<kesi
             if problem_index<=42
                NOF(time) = NOF(time) + (min(sum((repmat(A(i, 2:end), size(x,1), 1) - x).^2, 2).^0.5) < alfa);
             else
                NOF(time) = NOF(time) + (min(sum((repmat(optimalFit(i, :), size(x,1), 1) - x).^2, 2).^0.5) < alfa);
             end
              if problem_index>42
                if (min(sum((repmat(optimalFit(i,:), size(x,1), 1) - x).^2, 2).^0.5) < alfa)
                    a=a+1;
                    [qr1(a,:), index] = min(sum((repmat(optimalFit(i,:), size(x,1), 1) - x).^2, 2).^0.5);
                    qr(a,:)=quality_assessment(x_total(index,:), problem_index);
                end
              else
                  if (min(sum((repmat(A(i,2:end), size(x,1), 1) - x).^2, 2).^0.5) < alfa)
                    a=a+1;
                    [qr1(a,:), index] = min(sum((repmat(A(i,2:end), size(x,1), 1) - x).^2, 2).^0.5);  
                    qr(a,:)=quality_assessment(x(index,:), problem_index);
                  end
              end
            end
        end
        
        if isempty(qr)
            QR(time,:)=NaN;
            QR1(time,:)=NaN;
        else
            QR(time,:)=sum(qr,1)/size(qr,1);
            QR1(time,:)=sum(qr1,1)/size(qr1,1);
        end
        time = time + 1;
        if problem_index>42
            finalSolutions = [finalSolutions; x_total];
        else
            finalSolutions = [finalSolutions; x];
        end
        finalFit = [finalFit; fitMONES];
        
    end
    RR=sum(NOF)/(Rfit*totalTime)
    SR=size(find(NOF==Rfit),1)/totalTime
    % Display the experimental results
    total_NOF=[max(NOF);mean(NOF);min(NOF);std(NOF)];
    Evaluate_outcome=[min(QR);mean(QR);max(QR);std(QR)];
    Evaluate_outcome1=[min(QR1);mean(QR1);max(QR1);std(QR1)];
    QR(isnan(QR))=[];
    QR1(isnan(QR1))=[];
    if isempty(QR)
        Evaluate_outcome2=[NaN;NaN;NaN;NaN];
        Evaluate_outcome3=[NaN;NaN;NaN;NaN];
    else
        Evaluate_outcome2=[min(QR);mean(QR);max(QR);std(QR)];
        Evaluate_outcome3=[min(QR1);mean(QR1);max(QR1);std(QR1)];
    end
    
    
    disp( '*************************** ')
    disp(['NOF_problem', num2str((problem)), ': Max: ', num2str((max(NOF))), '; Mean: ', num2str((mean(NOF))), '; Min: ', num2str((min(NOF))) '; Std: ', num2str((std(NOF)))]);
    disp(['Quality_problem', num2str((problem)), ': Min: ', num2str((min(QR))), '; Mean: ', num2str((mean(QR))), ...
        '; Max: ', num2str((max(QR))) '; Std: ', num2str((std(QR)))]);
    toc;
    disp( '*************************** ')
    aa1=mean(IGD,1);
    
end
