function [new_pop, new_fit_v] = nondominated_sorting_and_selection(x, fit, popsize, m)

% popsize  the population size
% m  the number of objectives

front = 1;

new_pop = [];
new_fit_v = [];

while size(new_pop, 1) < popsize

    Ff = [];
    temp_pop = [];
    temp_fit_v = [];

    for i = 1 : size(x, 1)

        individual(i) = 0;

        for j = 1 : size(x, 1)

            dom_less = 0;
            dom_equal = 0;
            dom_more = 0;

            for k = 1 : m

                if fit(i, k) < fit(j, k)

                    dom_less = dom_less + 1;

                elseif fit(i, k) == fit(j, k)

                    dom_equal = dom_equal + 1;

                else

                    dom_more = dom_more + 1;

                end
                
            end

            if dom_less == 0 && dom_equal ~= m

                individual(i) = individual(i) + 1;

            end

        end

        if individual(i) == 0

            Ff = [Ff  i];

        end

    end

    temp_pop = x(Ff, :);
    temp_fit_v = fit(Ff, :);
    temp_fit_v(:, m + 1) = front;
    
    x (Ff, :) = [];
    fit(Ff, :) = [];

    for i = 1 : m

        [~, sorting_ID] = sort(temp_fit_v(:, i));

        sorted_based_on_objective = temp_fit_v(sorting_ID, :);

        f_max = sorted_based_on_objective(length(sorting_ID), i);
        f_min = sorted_based_on_objective(1, i);

        temp_fit_v(sorting_ID(length(sorting_ID)), m + 1 + i)= Inf;
        temp_fit_v(sorting_ID(1), m + 1 + i) = Inf;

        for j = 2 : length(sorting_ID) - 1
            next_obj  = sorted_based_on_objective(j + 1,  i);

            previous_obj  = sorted_based_on_objective(j - 1, i);

            if (f_max - f_min == 0)
                temp_fit_v(sorting_ID(j), m + 1 + i) = Inf;

            else
                temp_fit_v(sorting_ID(j), m + 1 + i) = (next_obj - previous_obj) / (f_max - f_min);
            end
        end
    end

    distance = sum(temp_fit_v(:, m + 1 + 1 : m + 1 + m), 2);

    temp_fit_v(:, m + 2) = distance;
    temp_fit_v = temp_fit_v(:, 1 : m + 2);

    [~, Index] = sort(temp_fit_v(:, m + 2), 'descend');

    temp_pop = temp_pop(Index, :);
    temp_fit_v = temp_fit_v(Index, :);

    new_pop = [new_pop; temp_pop];
    new_fit_v = [new_fit_v; temp_fit_v];

    front = front + 1;

end

new_pop = new_pop(1 : popsize, :);
new_fit_v = new_fit_v(1 : popsize, :);
