function mate_pool_population = tournament_selection(x, fit_v, pool_size, n, m, popsize)

chromosome = [x fit_v];

[~, a1] = sort(rand(1, popsize));
[~, a2] = sort(rand(1, popsize));

mate_pool_population = zeros(pool_size, n);

i = 1;
while i <= pool_size
    
    temp_parent1 = chromosome(a1(i), :);
    temp_parent2 = chromosome(a1(i + 1), :); 
    parent1 = tournament(temp_parent1, temp_parent2, n, m);
    
    temp_parent1 = chromosome(a1(i + 2), :);
    temp_parent2 = chromosome(a1(i + 3), :); 
    parent2 = tournament(temp_parent1, temp_parent2, n, m);
   
    mate_pool_population(i, 1 : n) = parent1(1 : n);
    mate_pool_population(i + 1, 1 : n) = parent2(1 : n);
    
    temp_parent1 = chromosome(a2(i), :);
    temp_parent2 = chromosome(a2(i + 1), :); 
    parent3 = tournament(temp_parent1, temp_parent2, n, m);
    
    temp_parent1 = chromosome(a2(i + 2), :);
    temp_parent2 = chromosome(a2(i + 3), :); 
    parent4 = tournament(temp_parent1, temp_parent2, n, m);
   
    mate_pool_population(i + 2, 1 : n) = parent3(1 : n);
    mate_pool_population(i + 3, 1 : n) = parent4(1 : n);
    
    i = i + 4;
    
end

function  parent = tournament(temp_parent1, temp_parent2, n, m)

distance = n + m + 2;
rank= n + m + 1;

if temp_parent1(rank) < temp_parent2(rank)
    
    parent = temp_parent1;
    
elseif temp_parent1(rank) > temp_parent2(rank)
    
    parent = temp_parent2;
    
elseif temp_parent1(distance) > temp_parent2(distance)
    
    parent = temp_parent1;
    
elseif temp_parent1(distance) < temp_parent2(distance)
    
    parent = temp_parent2;
    
elseif rand <= 0.5
    
    parent = temp_parent1;
    
else
    
    parent = temp_parent2;
    
end
